import { reactive, ref } from 'vue'
import { getDict } from '@/hooks/web/useDictionaries'

const dictObj = reactive({
  payUnit: [], // 薪资单位
  scale: [], // 规模
  industry: [], // 行业
  edu: [], // 学历
  exp: [], // 工作经验
  area: [], // 地区
  financing: [] // 融资阶段
})
const dictList = ref([
  { type: 'menduner_pay_unit', value: 'payUnit', key: 'payUnit', label: 'payName' },
  { type: 'menduner_financing_status', value: 'financing', key: 'financingStatus', label: 'financingName' },
  { type: 'menduner_scale', value: 'scale', key: 'scale', label: 'scaleName' },
  { type: 'menduner_industry_type', value: 'industry', key: 'industryId', label: 'industryName', params: {}, apiType: 'industryList', nameKey: 'nameCn', valueKey: 'id' },
  { type: 'menduner_education_type', value: 'edu', key: 'eduType', label: 'eduName' },
  { type: 'menduner_exp_type', value: 'exp', key: 'expType', label: 'expName' },
  { type: 'menduner_area_type', value: 'area', key: 'areaId', label: 'areaName', params: {}, apiType: 'areaList', nameKey: 'name', valueKey: 'id' }
])

// 字典
const getDictList = async () => {
  dictList.value.forEach(async (val) => {
    const { data } = await getDict(val.type, val.params, val.apiType)
    dictObj[val.value] = data
  })
}
export const getData = async () => {
  await getDictList()
}
getData()

export const dealDictArrayData = (res, list) => {
  dictList.value.forEach(item => {
    const valueKey = item.nameKey ? item.nameKey : 'label'
    const idKey = item.valueKey ? item.valueKey : 'value'
    const next = list.find(val => val[item?.key])
    if (!next) return
    res = list.map(e => {
      const obj = dictObj[item.value].find(k => Number(k[idKey]) === Number(e[item.key]))
      if (!obj) return
      e[item.label] = obj[valueKey] || ''
      e.active = false
      return e
    })
  })
  return res
}

export const dealDictObjData = (res, obj) => {
  Object.keys(obj).map(e => {
    const data = dictList.value.find(k => k.key === e)
    if (!data) return
    const valueKey = data.nameKey ? data.nameKey : 'label'
    const idKey = data.valueKey ? data.valueKey : 'value'
    const result = dictObj[data.value].find(val => val[idKey] === obj[e])
    if (!result) return
    res[data.label] = result[valueKey]
  })
  return res
}